	REM
	REM Robot Blask
	REM Created in IntyBASIC
	REM by Catsfolly
	REM February 2015.
	REM The original version fit in 10 lines of code.
	REM this is the readable version
			

REM some Intellivision hardware constants

	CONST BACKTAB		= $0200
	CONST CS_GRAM		= $0800				' get picture from gram
	CONST CS_CARD		= $01f8				' gram or grom card number

	CONST MB_X_XPOS		= $00FF				' mask for x pos
	CONST MB_X_INTR		= $0100				' enable collision regs
	CONST MB_X_VIS		= $0200				' make mob visible
	CONST MB_X_XSIZE	= $0400				' double size in x

	CONST MB_Y_YPOS		= $007F				' mask for y pos
	CONST MB_Y_YRES		= $0080				' 16 bits in y
	CONST MB_Y_YSIZ2	= $0100				' double y size
	CONST MB_Y_YSIZ4	= $0200				' 4 times y size
	CONST MB_Y_YSIZ8	= $0300				' 8 times y size
	CONST MB_Y_XFLIP	= $0400				' x flip
	CONST MB_Y_YFLIP	= $0800				' y flip

	CONST MB_A_GRAM		= $0800				' get picture from gram
	CONST MB_A_CARD		= $07f8				' mask for picture no.
	CONST MB_A_PRIO		= $2000				' priority (above/below bkgnd)


REM colors for color stack, border, etc

	CONST C_BLK  = $0              ' Black
	CONST C_BLU  = $1              ' Blue
	CONST C_RED  = $2              ' Red
	CONST C_TAN  = $3              ' Tan
	CONST C_DGR  = $4              ' Dark Green
	CONST C_GRN  = $5              ' Green
	CONST C_YEL  = $6              ' Yellow
	CONST C_WHT  = $7              ' White
	CONST C_GRY  = $8              ' Grey
	CONST C_CYN  = $9              ' Cyan
	CONST C_ORG  = $A              ' Orange
	CONST C_BRN  = $B              ' Brown
	CONST C_PNK  = $C              ' Pink
	CONST C_LBL  = $D              ' Light Blue
	CONST C_YGR  = $E              ' Yellow-Green
	CONST C_PUR  = $F              ' Purple

rem colors for backtab or mob a
	CONST X_BLK  = $0              ' Black
	CONST X_BLU  = $1              ' Blue
	CONST X_RED  = $2              ' Red
	CONST X_TAN  = $3              ' Tan
	CONST X_DGR  = $4              ' Dark Green
	CONST X_GRN  = $5              ' Green
	CONST X_YEL  = $6              ' Yellow
	CONST X_WHT  = $7              ' White
	CONST X_GRY  = $1000           ' Grey
	CONST X_CYN  = $1001           ' Cyan
	CONST X_ORG  = $1002           ' Orange
	CONST X_BRN  = $1003           ' Brown
	CONST X_PNK  = $1004           ' Pink
	CONST X_LBL  = $1005           ' Light Blue
	CONST X_YGR  = $1006           ' Yellow-Green
	CONST X_PUR  = $1007           ' Purple


title:
	cls		' clear the screen
	
	
    REM the screen is 20 chars wide so position is 20 * row + col
	 print at (20* 3 + 5) COLOR 5,"ROBOT BLAST!" ' print the game title (the title stays on the screen, just to be different.)
	 
	 print at (20*11 + 1) ,"S:      FREE:  /10"  ' print the labels at the bottom of the screen
	 
	DEFINE 0,10,gramchars ' load the custom character definitions
	WAIT
	
	REM declare and initialize some variables
	
	X=80 : Y = 50 ' cursor position
	
	shottimer=0 ' shot timer counts down to zero . zero means the shot animation is not active
	
	ex = 80 : ey = 50 ' center position of the explosion animation
	
	#etimer = 30 ' explosion animation timer counts up 30 means the animation is finished
	
	#rv = 1 ' starting robot speed (doubles as the score)
	
	free = 0 ' number of robots that have escaped (when this reaches 10 the game is over)
	
	dim #rx(2) : dim ry(2) ' robot x and y positions (x position has 3 fractional bits) 
	
	dim #rxv(2) ' robot x velocity (has 3 fractional bits) 
	
	dim ron(2) ' robot on screen flag - true if the robot is on screen 
	
	#rx(0) = 0
	#rx(1) = 160 * 8
	for i = 0 to 1 
		ry(i) = (rand AND $3f) + 15 ' set robot y to a random position within the screen dimensions
		ron(i) = 0 ' the robot is initially offscreen
	next i
		
REM *****************************************************************
REM
REM loop - main gameplay loop
REM
REM *****************************************************************
loop:	
	WAIT
	
	rem compute robot velocities 
	#rxv(0) = #rv/8 + 1 
	#rxv(1) = 0 - #rxv(0) 
	
	rem move the robots
	for i = 0 to 1 
		#rx(i) = (#rx(i) + #rxv(i)) AND $07ff 
	next i 
	
	newy = (rand AND $3f) + 15 ' compute a new y position just in case we need one
	
	rem if the robot is offscreen give it a new y. If it used to be on screen, incr the free count and clear ron. If it's on screen, set ron
	for i = 0 to 1
		if (#rx(i) > (200 * 8))  then ry(i) = newy : free = free + ron(i) : ron(i) = 0 else ron(i) = 1 
	next i
	
	rem do controls I tried to make them work for either controller for the readable version
	IF (cont1.left + cont2.left) THEN X=X-2 else if (cont1.right+cont2.right) then X=X+2 
	if (cont1.up + cont2.up)     then Y=Y-2 else if (cont1.down+cont2.down)   then Y=Y+2
	
	rem if the shot is inactive and the button is pressed, set shottimer to 60 and the shot position to the cursor position
	
	if shottimer = 0 then if (cont1.B0 + cont2.B0) then shottimer = 60 : sdx = X : sdy = y else sdy= 120 : goto nohit
	
	rem handle shot animation
	shottimer = shottimer -4 
	if shottimer > 0 then goto nohit
	
	test = (COL3 AND 2)  + (COL4 AND 4) 
	if test = 0 then goto nohit 
	
	rem shot connected - start the explosion animation
	ex = sdx : ey = sdy ' position is the same as the shot animation
	
	#etimer = 0 
	#rv = #rv+1 ' increase score and robot speed
	#exa = MB_A_GRAM + (5 * 8) + C_YEL	' a parameter for explosion sprites
	
	rem if test = 4 then robot 1 was hit, otherwise robot 0 was hit. Move the hit robot offsreen and set it's ron flag to zero
	if test = 4 THEN ron(1) = 0 : #rx(1) = (201 * 8) : #exa = #exa - (C_YEL - C_BLU) else ron(0)=0 : #rx(0) = 201 * 8

nohit:	
	if #etimer > 29 then Sprite 5,0,0,0  : Sprite 6,0,0,0 : SPRITE 7,0,0,0 : goto show_shot 
	
	#etimer = #etimer + 2 
	
	if (frame AND 1) then #einc = 0 - #etimer else #einc = #etimer ' alternate positive and negative offsets
	
	#einc = (#einc + ey) AND $7f 
	
	SPRITE 5,(ex - #etimer) + MB_X_INTR + MB_X_VIS, #einc +MB_Y_YSIZ2,#exa ' left	
	SPRITE 6,(ex + #etimer) + MB_X_INTR + MB_X_VIS, #einc +MB_Y_YSIZ2,#exa ' right
	SPRITE 7,ex             + MB_X_INTR + MB_X_VIS, #einc +MB_Y_YSIZ2,#exa ' center

show_shot:
	SPRITE 3,sdx - (shottimer - 4) + MB_X_INTR + MB_X_VIS, ((sdy + shottimer/4) AND $7f) +MB_Y_YSIZ2,MB_A_GRAM + 2 + (6 * 8) 
	SPRITE 4,sdx + (shottimer - 4) + MB_X_INTR + MB_X_VIS, ((sdy + shottimer/4) AND $7f) +MB_Y_YSIZ2,MB_A_GRAM + 2 + (6 * 8)
	
	rem show robots
	SPRITE 1,#rx(0)/8 + MB_X_INTR + MB_X_VIS, ry(0)+MB_Y_YSIZ2           ,MB_A_GRAM + C_YEL + (#rx(0) AND (3 * 8)) 
	SPRITE 2,#rx(1)/8 + MB_X_INTR + MB_X_VIS, ry(1)+MB_Y_YSIZ2+MB_Y_XFLIP,MB_A_GRAM + C_BLU + (3 * 8) - (#rx(1) AND (3 * 8)) 
	
	rem show cursor
	SPRITE 0,X + MB_X_INTR + MB_X_VIS, (Y AND $7f)+MB_Y_YSIZ2,MB_A_GRAM+ C_WHT + (4 * 8) 
	
	print at (20*11 + 3) color 7, <5> #rv-1 ' show score
	print at (20 * 11 + 14), <2> free	' show robots that are now free
	 
	if free < 10 goto loop ' not over yet...

gover_loop:
    print at (20 * 3 + 4) COLOR 7, "  GAME OVER  "  
	if (cont2.key <> 12) OR (cont1.key <>12) then goto title ' any keypad key restarts the game
	wait 
	goto gover_loop

REM main gameplay loop end *****************************************************************	
	
gramchars:

REM 0

	BITMAP "...####."
	BITMAP "...###.."
	BITMAP "...####."
	BITMAP "....#..."
	
	BITMAP "..######"
	BITMAP "..#.#..."
	BITMAP "....#..."
	BITMAP ".....#.."
	
REM 1

	BITMAP "...####."
	BITMAP "...###.."
	BITMAP "...####."
	BITMAP "....#..."
	
	BITMAP "..######"
	BITMAP "..#.#..."
	BITMAP "....##.."
	BITMAP "....#..."
	
REM 2

	BITMAP "...####."
	BITMAP "...###.."
	BITMAP "...####."
	BITMAP "....#..."
	
	BITMAP "..######"
	BITMAP "..#.#..."
	BITMAP "....#.#."
	BITMAP "...#...."
	
REM 3

	BITMAP "...####."
	BITMAP "...###.."
	BITMAP "...####."
	BITMAP "....#..."
	
	BITMAP "..######"
	BITMAP "..#.#..."
	BITMAP "...##..."
	BITMAP "......#."

REM 4

	BITMAP "   ##   "
	BITMAP "   ##   "
	BITMAP "   ##   "
	BITMAP "###  ###"
	
	BITMAP "###  ###"
	BITMAP "   ##   "
	BITMAP "   ##   "
	BITMAP "   ##   "
	
REM 5

	BITMAP "        "
	BITMAP "  ## #  "
	BITMAP "  # ###."
	BITMAP " # ## # "
	
	BITMAP " ## ### "
	BITMAP " # # ## "
	BITMAP "  ## #  "
	BITMAP "        "

REM 6

	BITMAP "        "
	BITMAP "  ####  "
	BITMAP " ######."
	BITMAP " ###### "
	
	BITMAP " ###### "
	BITMAP " ###### "
	BITMAP "  ####  "
	BITMAP "        "
	

	
